/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ THESE ARE THE MAP INFORMATIONS: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// CREATED BY DANY:
// OCTOBRE 2006
// FROM TEXAS BY ENSEMBLE:
// OCTOBER 2003:
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/	  
	    if (rmAllocateSubCivs(4) == true)
/*----------------------------------------------------------------------------------------------------------------*/	  
    {
/*----------------------------------------------------------------------------------------------------------------*/   
		subCiv0=rmGetCivID("Cree");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cree");

		subCiv1=rmGetCivID("Cree");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cree"); 

		subCiv2=rmGetCivID("Cree");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cree");

		subCiv3=rmGetCivID("Cree");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cree");
/*----------------------------------------------------------------------------------------------------------------*/		
    }		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/

// ****************************************** PICKS THE MAP SIZE: *********************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* THESE COME FROM THE RMS MAP FROM ENSEMBLE: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
/*	  
	     // NUMBER OF PLAYERS LOWER OR EQUAL TO 3:
		 int playerTiles=25000;
	
	     // CHANGE THE NUMBER OF PLAYER TILES:
         // DEPENDING ON THE NUMBER OF PLAYERS:
	     if (cNumberNonGaiaPlayers >3)
	  	     playerTiles = 20000;
	     if (cNumberNonGaiaPlayers >4)
		     playerTiles = 17500;
	     if (cNumberNonGaiaPlayers >5)
		     playerTiles = 15000;			
         if (cNumberNonGaiaPlayers >6)
		     playerTiles = 12500;
	     if (cNumberNonGaiaPlayers >7)
		     playerTiles = 10000;			

	     // DEFINE THE SHAPE OF THE MAP:
		 int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	     rmEchoInfo("Map size="+size+"m x "+size+"m");
	     rmSetMapSize(size, size);
*/	  
/*----------------------------------------------------------------------------------------------------------------*/	
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*----------------------------------------------------------------------------------------------------------------*/   
// ************************************ THIS IS TO MAKE A RECTANGULAR MAP: ************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
         // NUMBER OF PLAYERS LOWER OR EQUAL TO 3:
		 //int playerTiles = 13250;
	       int playerTiles = 25000;
/*----------------------------------------------------------------------------------------------------------------*/		
	     // CHANGE THE NUMBER OF PLAYER TILES:
         // DEPENDING ON THE NUMBER OF PLAYERS:
	     if (cNumberNonGaiaPlayers >3)
	  	     playerTiles = 20000;
	     if (cNumberNonGaiaPlayers >4)
		     playerTiles = 17500;
	     if (cNumberNonGaiaPlayers >5)
		     playerTiles = 15000;			
         if (cNumberNonGaiaPlayers >6)
		     playerTiles = 12500;
	     if (cNumberNonGaiaPlayers >7)
		     playerTiles = 10000;		
/*----------------------------------------------------------------------------------------------------------------*/	
	     // RECTANGULAR SHAPE FROM RMS PAMPAS: (AoE3)
	     // RECTANGULAR SHAPE NORTH-SOUTH:
	     int size=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles);
	     int longSide=1.4*size;      // 'Longside' is used to make the map rectangular
	     rmEchoInfo("Map size="+size+"m x "+longSide+"m");
	     rmSetMapSize(longSide, size);
/*----------------------------------------------------------------------------------------------------------------*/ 
/*	
         // RECTANGULAR SHAPE FROM RMS ARAUCANIA: (Warcheifs)
	     // RECTANGULAR SHAPE EAST-WEST:
	     int size = 1.4 * sqrt(cNumberNonGaiaPlayers * playerTiles);
         int longSide = 1.7 * size;
         rmSetMapSize(size,longSide);
         rmEchoInfo("Map size = "+size+"m x "+longSide+"m");
*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ************************************** DEFINE THE MAP PARAMETERS: ******************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	  // SET THE MAP ELEVATION PARAMETERS:
	  // rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	  rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	  rmSetMapElevationHeightBlend(1);
	
	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(4.0);
		  
	  // SET THE LIGHTING:
	  rmSetLightingSet("Texas");

      // PICKS THE DEFAULT WATER:
	  rmSetSeaType("Amazon River");
	
	  // SET BASE TERRAIN MIX:
	  //rmSetBaseTerrainMix("texas_grass");
	    rmSetBaseTerrainMix("texas_dirt");
	
	  // TERRAIN INITIALIZATION:
	  //rmTerrainInitialize("texas\ground1_tex", 5.0);
	    rmTerrainInitialize("texas\groundforestdirt_tex", 5.0);
		
	  // SET THE MAP TYPE:
	  rmSetMapType("texas");
	  rmSetMapType("grass");
	  rmSetMapType("land");

	  // CHOOSE THE MERCS:
	  chooseMercs();

	  // CORNER CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES. THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*----------------------------------------------------------------------------------------------------------------*/
    int classPlayer=rmDefineClass("player");
    rmDefineClass("startingUnit");
    rmDefineClass("classForest");
	rmDefineClass("importantItem");
    rmDefineClass("natives");
	rmDefineClass("nuggets");
	rmDefineClass("socketClass");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*----------------------------------------------------------------------------------------------------------------*/
      // MAP EDGE CONSTRAINTS:
      int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);
	 
	  int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  //DAL - was 24
	  int islandEdgeConstraint=rmCreateBoxConstraint("islands in center", 0.30, 0.30, 0.70, 0.70, 0.01);
      int elkEdgeConstraint=rmCreateBoxConstraint("elk edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);
      //int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(7), rmZTilesToFraction(7), 1.0-rmXTilesToFraction(7), 1.0-rmZTilesToFraction(7), 0.01);
	    int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);
	  int nuggetEdgeConstraint=rmCreateBoxConstraint("nugget edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);
	  int sheepEdgeConstraint=rmCreateBoxConstraint("sheep edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);
	  int forestEdgeConstraint=rmCreateBoxConstraint("forest edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);
	   	  
	  
	  
	  // CARDINAL DIRECTIONS:
      int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
      int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
      int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
      int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
      
	  // CREATE BOX CONSTRAINT:
	  int NWconstraint = rmCreateBoxConstraint("stay in NW portion", 0, 0.5, 1, 1);
	  int SEconstraint = rmCreateBoxConstraint("stay in SE portion", 0, 0, 1, 0.5);
	  int NEconstraint = rmCreateBoxConstraint("stay in NE portion", 0.65, 0.0, 1, 1);
	  int SWconstraint = rmCreateBoxConstraint("stay in SW portion", 0, 0.0, 0.5, 1);
	  int extremeNEconstraint = rmCreateBoxConstraint("stay deep into NE portion", 0.6, 0.0, 1.0, 1.0);
      int Westconstraint = rmCreateBoxConstraint("stay in East Box", 0, 1.0, 0.4, 0.6); 
	  int Eastconstraint = rmCreateBoxConstraint("stay in West Box", 1.0, 0.0, 0.6, 0.4); 
	
      // PLAYER CONSTRAINTS:
      //int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 20.0);
      int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
      int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
    
	  // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
      int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
      int avoidRiver = rmCreateTerrainDistanceConstraint("avoid river", "Land", false, 5.0);	  
	  
	  // ALL:
      //int avoidAllClose = rmCreateTypeDistanceConstraint("Avoid everything a little", "all", 6.0);
      int avoidAllMedium = rmCreateTypeDistanceConstraint("Avoid everything more", "all", 10.0);
      //int avoidAllFar = rmCreateTypeDistanceConstraint("Avoid everything a lot", "all", 20.0);
	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	  
	  // Constraint to avoid water.
      int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 8.0);
      int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water 16", "Land", false, 16.0);

	  
	  // NATURE AVOIDANCE:
	  int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
	  //int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
	  int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
	  int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
	  int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 20.0);
	  int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
	  
	  
      // UNIT AVOIDANCE:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
      int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
  	  int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 20.0);
      int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
      int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
      int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 35.0);
	  int avoidNuggetFar=rmCreateTypeDistanceConstraint("nugget avoid nugget far", "AbstractNugget", 45.0);
	  int avoidNuggetsSmall=rmCreateClassDistanceConstraint("objects avoid starting nuggets small", rmClassID("nuggets"), 10.0);
   	  int avoidElk=rmCreateTypeDistanceConstraint("stuff avoid elk", "elk", 10.0);
	  int elkAvoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "elk", 12.0);
	  int avoidTC=rmCreateTypeDistanceConstraint("avoid Town Center", "TownCenter", 20.0);
	  int avoidBison=rmCreateTypeDistanceConstraint("stuff avoid bison", "bison", 10.0);
	  int bisonAvoidBison=rmCreateTypeDistanceConstraint("bison avoids bison", "bison", 12.0);
	  
      // TRADE ROUTE AVOIDANCE:
	  int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
      int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);	  
	  
	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	  
	  // BOX CONSTRAINTS:
      //int notInTheMountains = rmCreateBoxConstraint("Don't place in the mountains", 0.0, 0.03, 0.93, 0.97, 0);
	  int notInTheMountains = rmCreateBoxConstraint("Don't place in the mountains", 0.0, 0.03, 0.93, 0.97, 0);
      int edgeConstraint = rmCreateBoxConstraint("Edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************* DEFINE THE OBJECTS: ********************************************** //
// *********************** THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: *************************** //
/*================================================================================================================*/
// NONE FOR NOW: 
/*================================================================================================================*/
// *************************************** DONE THE DEFINING OBJECTS: ******************************************* //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/ 
// ************************************* PLACE THE PLAYERS ON THE MAP: ****************************************** //
/*================================================================================================================*/
   	    if ( cNumberTeams == 2 ) // IT IS USED IF THE NUMBER OF TEAMS IS 2:
/*----------------------------------------------------------------------------------------------------------------*/		
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		rmSetPlacementTeam(0);
/*----------------------------------------------------------------------------------------------------------------*/		
		rmSetPlacementSection(0.15, 0.35);
/*----------------------------------------------------------------------------------------------------------------*/		
		if (cNumberNonGaiaPlayers >6) // IT IS USED IF THE NUMBER OF PLAYERS IS GREATER THAN 6:
		{
			rmSetPlacementSection(0.13, 0.37);
		}
/*----------------------------------------------------------------------------------------------------------------*/		
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/		   
		rmSetPlacementTeam(1);
/*----------------------------------------------------------------------------------------------------------------*/		
		rmSetPlacementSection(0.65, 0.85);
/*----------------------------------------------------------------------------------------------------------------*/		
		if (cNumberNonGaiaPlayers >6) // IT IS USED IF THE NUMBER OF PLAYERS IS GREATER THAN 6:
		{
			rmSetPlacementSection(0.63, 0.87);
		}
/*----------------------------------------------------------------------------------------------------------------*/		
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/		   
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	else
/*----------------------------------------------------------------------------------------------------------------*/	
	{
  		// IT IS USED IF THE NUMBER OF TEAMS IS NOT EQUAL TO 2 OR IF THERE IS NOT MORE THAN 6 PLAYERS:
        // THE PLAYERS WILL BE PLACE IN A CIRCULAR MANNER LIKE A CLOCK:		
		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************ PLACEMENT, DEFINING AND PLACING: **************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
 /*     // DEFINE TEAM PLACEMENT:
      int teamZeroCount = rmGetNumberPlayersOnTeam(0);
      int teamOneCount = rmGetNumberPlayersOnTeam(1);*/
/*----------------------------------------------------------------------------------------------------------------*/   
     // float teamPlacement = rmRandFloat(0, 1);
/*----------------------------------------------------------------------------------------------------------------*/
/*      if (cNumberTeams > 2) 
      { // FREE-FOR-ALL:
         rmPlacePlayersCircular(0.25, 0.25, 0.9);
      }
      else
      {
         if (teamZeroCount == teamOneCount) // TEAMS HAVE AN EVEN NUMBER OF PLAYERS:
         {
            if (teamPlacement > 0.50) // PLACES TEAMS 0 IN THE SOUTH 50% OF THE TIME:
            {
               rmSetPlacementTeam(0);
               rmPlacePlayersLine(0.45, 0.15, 0.75, 0.25, 0.0, 0.0);
            
               rmSetPlacementTeam(1);
               rmPlacePlayersLine(0.45, 0.80, 0.75, 0.75, 0.0, 0.0);            
            }
            else // PLACES TEAM 0 IN THE NORTH 50% OF THE TIME:
            {
               rmSetPlacementTeam(0);
               rmPlacePlayersLine(0.45, 0.80, 0.75, 0.75, 0.0, 0.0);

               rmSetPlacementTeam(1);
               rmPlacePlayersLine(0.45, 0.15, 0.75, 0.25, 0.0, 0.0);
            }
         }
         else // TEAMS HAVE AN UNEVEN NUMBER OF PLAYERS:
         {
            if (teamZeroCount > teamOneCount) 
            { // Team 0 is bigger
               rmSetPlacementTeam(0);
               rmPlacePlayersLine(0.30, 0.10, 0.80, 0.40, 10.0, 0.25);

               rmSetPlacementTeam(1);
               rmPlacePlayersLine(0.30, 0.90, 0.75, 0.75, 10.0, 0.25);
            }
            else // TEAM 1 IS BIGGER:
            {
               rmSetPlacementTeam(0);
               rmPlacePlayersLine(0.30, 0.90, 0.75, 0.75, 10.0, 0.25);

               rmSetPlacementTeam(1);
               rmPlacePlayersLine(0.30, 0.10, 0.80, 0.40, 10.0, 0.25); 
            }
         }
      }*/
/*----------------------------------------------------------------------------------------------------------------*/	  
   /*   rmBuildAllAreas();*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTE 1: ************************************** //
/*================================================================================================================*/
      int tradeRoute = rmCreateTradeRoute();
	  int socket = rmCreateObjectDef("Sockets for Trade Route 1");
/*----------------------------------------------------------------------------------------------------------------*/
      rmSetObjectDefTradeRouteID(socket, tradeRoute);
      rmAddObjectDefItem(socket, "socketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socket, true);
      rmSetObjectDefMinDistance(socket, 0.0);
      rmSetObjectDefMaxDistance(socket, 8.0);
/*================================================================================================================*/	  
// ******************** ADD WAYPOINTS FOR THE ROUTE - STARTS IN THE NORTH AND GOES SOUTH: *********************** //
/*================================================================================================================*/
      //rmAddTradeRouteWaypoint(tradeRoute, 0.85, 0.95);
        rmAddTradeRouteWaypoint(tradeRoute, 0.9, 0.9);
	  
	    rmAddTradeRouteWaypoint(tradeRoute, 0.75, 0.9);
        rmAddTradeRouteWaypoint(tradeRoute, 0.60, 0.75);
        rmAddTradeRouteWaypoint(tradeRoute, 0.45, 0.75);
        rmAddTradeRouteWaypoint(tradeRoute, 0.30, 0.9);
      
	  //rmAddTradeRouteWaypoint(tradeRoute, 0.85, 0.05);
	    rmAddTradeRouteWaypoint(tradeRoute, 0.1, 0.9);
/*----------------------------------------------------------------------------------------------------------------*/
      bool placedTradeRoute = rmBuildTradeRoute(tradeRoute, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/
// *********************** PLACE THE SOCKETS ALONG THE TRADE ROUTE - USES PERCENTAGES: ************************** //
/*================================================================================================================*/
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.05);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
	  socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.35);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.65);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.95);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTE 2: ************************************** //
/*================================================================================================================*/
      int tradeRoute2 = rmCreateTradeRoute();
      int socket2 = rmCreateObjectDef("Sockets for Trade Route 2"); 
/*----------------------------------------------------------------------------------------------------------------*/
      rmSetObjectDefTradeRouteID(socket2, tradeRoute2);
      rmAddObjectDefItem(socket2, "socketTradeRoute2", 1, 0.0);
      rmSetObjectDefAllowOverlap(socket2, true);
      rmSetObjectDefMinDistance(socket2, 0.0);
      rmSetObjectDefMaxDistance(socket2, 8.0);
/*================================================================================================================*/	  
// ******************** ADD WAYPOINTS FOR THE ROUTE - STARTS IN THE NORTH AND GOES SOUTH: *********************** //
/*================================================================================================================*/
	  rmAddTradeRouteWaypoint(tradeRoute2, 0.1, 0.125);
	  
	  rmAddTradeRouteWaypoint(tradeRoute2, 0.3, 0.140);
      rmAddTradeRouteWaypoint(tradeRoute2, 0.5, 0.250);
      rmAddTradeRouteWaypoint(tradeRoute2, 0.6, 0.250);
      rmAddTradeRouteWaypoint(tradeRoute2, 0.8, 0.140);
	  
	  rmAddTradeRouteWaypoint(tradeRoute2, 0.9, 0.1);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2, "dirt");
      if(placedTradeRoute2 == false)
      rmEchoError("Failed to place trade route");
/*================================================================================================================*/
// *********************** PLACE THE SOCKETS ALONG THE TRADE ROUTE - USES PERCENTAGES: ************************** //
/*================================================================================================================*/
      vector socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.05);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
	  socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.38);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
	  socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.65);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
	  socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.95);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ****************************************** SET UP PLAYER AREAS: ********************************************** //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/	  
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint); 
      //rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  rmSetAreaLocPlayer(id, i);
		//rmSetAreaTerrainType(id, "texas\ground2");
		  rmSetAreaTerrainType(id, "texas\groundforestdirt_tex");
      rmSetAreaWarnFailure(id, false);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*----------------------------------------------------------------------------------------------------------------*/   
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************** DEFINE THE ANDES CLIFFS 1: ******************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
       int andesCliffs = rmCreateArea("The Andes Cliffs 1");
       //rmAddAreaInfluenceSegment(andesCliffs, 1.0, 0.0, 1.0, 1.0);
         rmAddAreaInfluenceSegment(andesCliffs, 0.0, 1.0, 1.0, 1.0);   
       //rmSetAreaLocation(andesCliffs, 0.97, 0.5);
         rmSetAreaLocation(andesCliffs, 0.5, 1.0);
       //rmSetAreaSize(andesCliffs, 0.045, 0.045);
         rmSetAreaSize(andesCliffs, 0.025, 0.025);
       //rmSetAreaMix(andesCliffs, andesMixName);
       //rmSetAreaMix(andesCliffs, "araucania_grass_a");
	     rmSetAreaMix(andesCliffs, "texas_dirt");

       rmSetAreaCoherence(andesCliffs, 0.75);
       rmSetAreaEdgeFilling(andesCliffs, 1.0);
       rmSetAreaSmoothDistance(andesCliffs, 10.0);
       rmSetAreaHeightBlend(andesCliffs, 6.0);
   
       // SPECIFIC CLIFF STUFF:
       rmSetAreaCliffHeight(andesCliffs, 8.0, 2.0, 0.0);
       //rmSetAreaCliffType(andesCliffs, cliffName);
       //rmSetAreaCliffType(andesCliffs, "Araucania Central");
	   //rmSetAreaCliffType(andesCliffs, "Texas Grass");
	   	 rmSetAreaCliffType(andesCliffs, "Texas");
       rmSetAreaCliffEdge(andesCliffs, 1.0, 1.0, 0.0, 1.0, 0);
       rmSetAreaCliffPainting(andesCliffs, true, true, true, 1.0, true);

       rmSetAreaWarnFailure(andesCliffs, false);
       rmBuildArea(andesCliffs);
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************** DEFINE THE ANDES CLIFFS 2: ******************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
       int andes2Cliffs = rmCreateArea("The Andes Cliffs 2");
       //rmAddAreaInfluenceSegment(andes2Cliffs, 1.0, 0.0, 1.0, 1.0);
         rmAddAreaInfluenceSegment(andes2Cliffs, 0.0, 0.0, 1.0, 0.0);   
       //rmSetAreaLocation(andes2Cliffs, 0.97, 0.5);
         rmSetAreaLocation(andes2Cliffs, 0.5, 0.0);
       //rmSetAreaSize(andes2Cliffs, 0.045, 0.045);
         rmSetAreaSize(andes2Cliffs, 0.025, 0.025);
       //rmSetAreaMix(andes2Cliffs, andesMixName);
       //rmSetAreaMix(andes2Cliffs, "araucania_grass_a");
	     rmSetAreaMix(andes2Cliffs, "texas_dirt");

       rmSetAreaCoherence(andes2Cliffs, 0.75);
       rmSetAreaEdgeFilling(andes2Cliffs, 1.0);
       rmSetAreaSmoothDistance(andes2Cliffs, 10.0);
       rmSetAreaHeightBlend(andes2Cliffs, 6.0);
   
       // SPECIFIC CLIFF STUFF:
       rmSetAreaCliffHeight(andes2Cliffs, 8.0, 2.0, 0.0);
       //rmSetAreaCliffType(andes2Cliffs, cliffName);
       //rmSetAreaCliffType(andes2Cliffs, "Araucania Central");
	   //rmSetAreaCliffType(andes2Cliffs, "Texas Grass");
	     rmSetAreaCliffType(andes2Cliffs, "Texas");
	   
       rmSetAreaCliffEdge(andes2Cliffs, 1.0, 1.0, 0.0, 1.0, 0);
       rmSetAreaCliffPainting(andes2Cliffs, true, true, true, 1.0, true);

       rmSetAreaWarnFailure(andes2Cliffs, false);
       rmBuildArea(andes2Cliffs); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE RIVER: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
           	// RIVER 1:		
			//int riverID = rmRiverCreate(-1, "Andes River", 12, 8, 3, 3);
			//int riverID = rmRiverCreate(-1, "Andes River", 10, 10, 6, 5);
			  int riverID = rmRiverCreate(-1, "Pampas River", 10, 10, 6, 5);
			//rmRiverAddWaypoint(riverID, 0.9, 1.0);
			  //rmRiverAddWaypoint(riverID, 0.5, 1.0);
			    rmRiverAddWaypoint(riverID, 0.0, 0.35);
			rmRiverAddWaypoint(riverID, 0.35, 0.35);// test
			//rmRiverAddWaypoint(riverID, 0.0, 0.75);
			  rmRiverAddWaypoint(riverID, 1.0, 0.35);
			rmRiverSetShallowRadius(riverID, 10);
			//rmRiverAddShallow(riverID, rmRandFloat(0.45, 0.65));
			  rmRiverAddShallow(riverID, rmRandFloat(0.50, 0.50));
			rmRiverSetBankNoiseParams(riverID, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
			rmRiverBuild(riverID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ***************************** DEFINE THE STARTING TCID AND THE STARTING UNITS: ******************************* //
/*================================================================================================================*/
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
      rmSetObjectDefMinDistance(startingUnits, 5.0);
      rmSetObjectDefMaxDistance(startingUnits, 10.0);
	  //rmAddObjectDefConstraint(startingUnits, avoidAll);

	  int startingTCID= rmCreateObjectDef("startingTC");
	  if ( rmGetNomadStart())
	  {
		  rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	  }
	  else
	  {
		  rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
		  rmSetObjectDefMinDistance(startingTCID, 5.0);
          rmSetObjectDefMaxDistance(startingTCID, 20.0);
		  rmAddObjectDefConstraint(startingTCID, playerEdgeConstraint);
		  rmAddObjectDefConstraint(startingTCID, avoidTC);
		  // Give it a little wiggle room for maps with greater than four players
		  if ( cNumberNonGaiaPlayers > 4 )
		  {
			  rmSetObjectDefMinDistance(startingTCID, 0.0);
			  rmSetObjectDefMaxDistance(startingTCID, 6.0);
		  }
	  }
/*================================================================================================================*/
// ************************************* DEFINE THE STARTING RESOURCES: ***************************************** //
/*================================================================================================================*/
        // DEFINE THE STARTING TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 16);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	    rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
        
		// DEFINE THE MORE STARTING TREES:
        int startingTrees2ID = rmCreateObjectDef("More starting trees");
        rmAddObjectDefItem(startingTrees2ID, "TreeTexasDirt", 6, 8.0);
        rmSetObjectDefMinDistance(startingTrees2ID, 16.0);
        rmSetObjectDefMaxDistance(startingTrees2ID, 22.0);
		//rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        //rmAddObjectDefToClass(startingTrees2ID, rmClassID("startingUnits);
		rmAddObjectDefConstraint(startingTrees2ID, avoidStartingUnits);
        rmAddObjectDefConstraint(startingTrees2ID, avoidAllMedium);
		rmAddObjectDefConstraint(startingTrees2ID, avoidStartResource);
        rmAddObjectDefConstraint(startingTrees2ID, edgeConstraint);
		
        // DEFINE THE STARTING PRONGHORN:
		int StartPronghornID=rmCreateObjectDef("starting pronghorn");
	    rmAddObjectDefItem(StartPronghornID, "pronghorn", 4, 4.0);
	    rmSetObjectDefMinDistance(StartPronghornID, 5);
	    rmSetObjectDefMaxDistance(StartPronghornID, 12);
	    rmAddObjectDefConstraint(StartPronghornID, avoidStartResource);
	    rmAddObjectDefConstraint(StartPronghornID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartPronghornID, avoidNatives);
	    rmSetObjectDefCreateHerd(StartPronghornID, true);

        // DEFINE THE STARTING BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

        // PLACE THE STARTING BISONS:
		int playerBisonID=rmCreateObjectDef("player bison herd");
        rmAddObjectDefItem(playerBisonID, "bison", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(playerBisonID, 40.0);
        rmSetObjectDefMaxDistance(playerBisonID, 45.0);
		rmAddObjectDefConstraint(playerBisonID, avoidBison);
	    rmAddObjectDefConstraint(playerBisonID, bisonAvoidBison);
	    rmAddObjectDefConstraint(playerBisonID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerBisonID, avoidCoin);
		rmAddObjectDefConstraint(playerBisonID, avoidSocket);
		rmAddObjectDefConstraint(playerBisonID, avoidNugget);
	    rmAddObjectDefConstraint(playerBisonID, avoidImportantItem);
	    rmSetObjectDefCreateHerd(playerBisonID, true);

	    // PLACE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteCliff);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    //rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem); // REMOVED BY ENSEMBLE:	

        // PLACE THE SILVER MINES:
		int playerGoldID=rmCreateObjectDef("player silver ore");
	    int silverType = rmRandInt(1,10);
    			
/*================================================================================================================*/
// ***************************** PLACE THE STARTING TCID AND THE STARTING UNITS: ******************************** //
/*================================================================================================================*/
    	for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		// PLACE THE STARTING UNITS AND A TC:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
/*----------------------------------------------------------------------------------------------------------------*/		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
        // DEFINE THE MORE STARTING TREES:
		rmPlaceObjectDefAtLoc(startingTrees2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
// ************* EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY: ************ //
/*----------------------------------------------------------------------------------------------------------------*/
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		//rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		//rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		//rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver further "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		//rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		//rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		//rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 40.0);
		rmSetObjectDefMaxDistance(playerGoldID, 50.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));		
/*----------------------------------------------------------------------------------------------------------------*/
        // PLACE THE STARTING PRONGHORN: 
		rmPlaceObjectDefAtLoc(StartPronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
        // PLACE THE STARTING BERRYBUSH:
        rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
        // EVERYONE GETS TWO BISON HERDS:
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
        // PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ******************* DEFINE AND PLACE THE NATIVE VILLAGES AND SECRETS OF THE NEW WORLD: *********************** //
/*================================================================================================================*/
	    if (subCiv0 == rmGetCivID("Cree"))
	{  
		int creeVillageID = -1;
		//creeVillageID = rmCreateGrouping("cree village", "native cree village 1");
		  creeVillageID = rmCreateGrouping("cree village", "native cree village 1");
		rmSetGroupingMinDistance(creeVillageID, 0.0);
		//rmSetGroupingMaxDistance(creeVillageID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(creeVillageID, 0.0);
		rmAddGroupingConstraint(creeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(creeVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(creeVillageID, avoidNatives);
		//rmAddGroupingConstraint(creeVillageID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(creeVillageID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(creeVillageID, 0, 0.9, 0.38);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv1 == rmGetCivID("Cree"))
	{  
		int cree1VillageID = -1;
		//cree1VillageID = rmCreateGrouping("cree village 1", "native cree village 1");
		  cree1VillageID = rmCreateGrouping("cree village 1", "native cree village 1");
		rmSetGroupingMinDistance(cree1VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree1VillageID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(cree1VillageID, 0.0);
		rmAddGroupingConstraint(cree1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree1VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree1VillageID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(cree1VillageID, 0, 0.5, 0.5);
		  //rmPlaceGroupingAtLoc(cree1VillageID, 0, 0.15, 0.78);
		    rmPlaceGroupingAtLoc(cree1VillageID, 0, 0.09, 0.6);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv2 == rmGetCivID("Cree"))
	{  
		int cree2VillageID = -1;
		//cree2VillageID = rmCreateGrouping("cree village 2", "native cree village 1");
		  cree2VillageID = rmCreateGrouping("cree village 2", "native cree village 1");
		rmSetGroupingMinDistance(cree2VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree2VillageID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(cree2VillageID, 0.0);
		rmAddGroupingConstraint(cree2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree2VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree2VillageID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(cree2VillageID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(cree2VillageID, 0, 0.50, 0.14);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv3 == rmGetCivID("Cree"))
	{  
		int cree3VillageID = -1;
		//cree3VillageID = rmCreateGrouping("cree village 3", "native maya village 1");
		  cree3VillageID = rmCreateGrouping("cree village 3", "native cree village 1");
		rmSetGroupingMinDistance(cree3VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree3VillageID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(cree3VillageID, 0.0);
		rmAddGroupingConstraint(cree3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree3VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree3VillageID, insideCircleConstraint);
		//rmPlaceGroupingAtLoc(cree3VillageID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(cree3VillageID, 0, 0.5, 0.85);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE FOUR SILVER MINES RANDOM: ******************************** //
/*================================================================================================================*/
	  // DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  int silverRandomID = rmCreateObjectDef("silverRandom 1");
	  rmAddObjectDefItem(silverRandomID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandomID, 0.0);
      //rmSetObjectDefMaxDistance(silverRandomID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(silverRandomID, 0.0);
	  rmAddObjectDefConstraint(silverRandomID, avoidCoin);
      //rmAddObjectDefConstraint(silverRandomID, avoidAll);
	  //rmAddObjectDefConstraint(silverRandomID, avoidSocket);
	  //rmAddObjectDefConstraint(silverRandomID, avoidElk);
      //rmAddObjectDefConstraint(silverRandomID, avoidWater8);
	  //rmAddObjectDefConstraint(silverRandomID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(silverRandomID, avoidNatives);
      //rmAddObjectDefConstraint(silverRandomID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(silverRandomID, Eastconstraint);
	  //rmAddObjectDefConstraint(silverRandomID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(silverRandomID, 0, 0.5, 0.5);
	    //rmPlaceObjectDefAtLoc(silverRandomID, 0, 0.09, 0.58);
		  rmPlaceObjectDefAtLoc(silverRandomID, 0, 0.12, 0.79);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }	
/*----------------------------------------------------------------------------------------------------------------*/
 // DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  int silverRandom2ID = rmCreateObjectDef("silverRandom 2");
	  rmAddObjectDefItem(silverRandom2ID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandom2ID, 0.0);
      //rmSetObjectDefMaxDistance(silverRandom2ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(silverRandom2ID, 0.0);
	  rmAddObjectDefConstraint(silverRandom2ID, avoidCoin);
      //rmAddObjectDefConstraint(silverRandom2ID, avoidAll);
	  //rmAddObjectDefConstraint(silverRandom2ID, avoidSocket);
	  //rmAddObjectDefConstraint(silverRandom2ID, avoidElk);
      //rmAddObjectDefConstraint(silverRandom2ID, avoidWater8);
	  //rmAddObjectDefConstraint(silverRandom2ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(silverRandom2ID, avoidNatives);
      //rmAddObjectDefConstraint(silverRandom2ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(silverRandom2ID, Westconstraint);
	  //rmAddObjectDefConstraint(silverRandom2ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(silverRandom2ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(silverRandom2ID, 0, 0.88, 0.24);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*----------------------------------------------------------------------------------------------------------------*/
// DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  int silverRandom3ID = rmCreateObjectDef("silverRandom 3");
	  rmAddObjectDefItem(silverRandom3ID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandom3ID, 0.0);
      //rmSetObjectDefMaxDistance(silverRandom3ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(silverRandom3ID, 0.0);
	  rmAddObjectDefConstraint(silverRandom3ID, avoidCoin);
      //rmAddObjectDefConstraint(silverRandom3ID, avoidAll);
	  //rmAddObjectDefConstraint(silverRandom3ID, avoidSocket);
	  //rmAddObjectDefConstraint(silverRandom3ID, avoidElk);
      //rmAddObjectDefConstraint(silverRandom3ID, avoidWater8);
	  //rmAddObjectDefConstraint(silverRandom3ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(silverRandom3ID, avoidNatives);
      //rmAddObjectDefConstraint(silverRandom3ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(silverRandom3ID, Westconstraint);
	  //rmAddObjectDefConstraint(silverRandom3ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(silverRandom3ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(silverRandom3ID, 0, 0.6, 0.10);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }   
/*----------------------------------------------------------------------------------------------------------------*/
// DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  int silverRandom4ID = rmCreateObjectDef("silverRandom 4");
	  rmAddObjectDefItem(silverRandom4ID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandom4ID, 0.0);
      //rmSetObjectDefMaxDistance(silverRandom4ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(silverRandom4ID, 0.0);
	  rmAddObjectDefConstraint(silverRandom4ID, avoidCoin);
      //rmAddObjectDefConstraint(silverRandom4ID, avoidAll);
	  //rmAddObjectDefConstraint(silverRandom4ID, avoidSocket);
	  //rmAddObjectDefConstraint(silverRandom4ID, avoidElk);
      //rmAddObjectDefConstraint(silverRandom4ID, avoidWater8);
	  //rmAddObjectDefConstraint(silverRandom4ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(silverRandom4ID, avoidNatives);
      //rmAddObjectDefConstraint(silverRandom4ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(silverRandom4ID, Westconstraint);
	  //rmAddObjectDefConstraint(silverRandom4ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(silverRandom4ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(silverRandom4ID, 0, 0.6, 0.87);
/*----------------------------------------------------------------------------------------------------------------*/	  
   } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE DOMESTIC ANIMALS: ************************************* // 
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  //int cow1ID = rmCreateObjectDef("cow 1"+i);
	    int cow1ID = rmCreateObjectDef("cow 1");
	  rmAddObjectDefItem(cow1ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow1ID, 0.0);
      //rmSetObjectDefMaxDistance(cow1ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow1ID, 0.0);
	  //rmAddObjectDefConstraint(cow1ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow1ID, avoidAll);
      //rmAddObjectDefConstraint(cow1ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow1ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow1ID, avoidNatives);
      //rmAddObjectDefConstraint(cow1ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow1ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow1ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow1ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow1ID, 0, 0.55, 0.9);
/*----------------------------------------------------------------------------------------------------------------*/	
	  //int cow2ID = rmCreateObjectDef("cow 2"+i);
	    int cow2ID = rmCreateObjectDef("cow 2");
	  //rmAddObjectDefItem(cow2ID, "cow", rmRandInt(8,10), 0.0);
	    rmAddObjectDefItem(cow2ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow2ID, 0.0);
      //rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow2ID, 0.0);
	  //rmAddObjectDefConstraint(cow2ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow2ID, avoidAll);
      //rmAddObjectDefConstraint(cow2ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow2ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow2ID, avoidNatives);
      //rmAddObjectDefConstraint(cow2ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow2ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow2ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow2ID, 0, 0.40, 0.9);   
/*----------------------------------------------------------------------------------------------------------------*/
       	//int cow3ID = rmCreateObjectDef("cow 3"+i);
	    int cow3ID = rmCreateObjectDef("cow 3");
	  //rmAddObjectDefItem(cow3ID, "cow", rmRandInt(8,10), 0.0);
	    rmAddObjectDefItem(cow3ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow3ID, 0.0);
      //rmSetObjectDefMaxDistance(cow3ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow3ID, 0.0);
	  //rmAddObjectDefConstraint(cow3ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow3ID, avoidAll);
      //rmAddObjectDefConstraint(cow3ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow3ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow3ID, avoidNatives);
      //rmAddObjectDefConstraint(cow3ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow3ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow3ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow3ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow3ID, 0, 0.40, 0.11); 
/*----------------------------------------------------------------------------------------------------------------*/
	//int cow4ID = rmCreateObjectDef("cow 4"+i);
	    int cow4ID = rmCreateObjectDef("cow 4");
	  //rmAddObjectDefItem(cow4ID, "cow", rmRandInt(8,10), 0.0);
	    rmAddObjectDefItem(cow4ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow4ID, 0.0);
      //rmSetObjectDefMaxDistance(cow4ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow4ID, 0.0);
	  //rmAddObjectDefConstraint(cow4ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow4ID, avoidAll);
      //rmAddObjectDefConstraint(cow4ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow4ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow4ID, avoidNatives);
      //rmAddObjectDefConstraint(cow4ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow4ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow4ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow4ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow4ID, 0, 0.70, 0.11);
/*----------------------------------------------------------------------------------------------------------------*/		
      //int cow5ID = rmCreateObjectDef("cow 5"+i);
	    int cow5ID = rmCreateObjectDef("cow 5");
	  //rmAddObjectDefItem(cow5ID, "cow", rmRandInt(8,10), 0.0);
	    rmAddObjectDefItem(cow5ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow5ID, 0.0);
      //rmSetObjectDefMaxDistance(cow5ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow5ID, 0.0);
	  //rmAddObjectDefConstraint(cow5ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow5ID, avoidAll);
      //rmAddObjectDefConstraint(cow5ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow5ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow5ID, avoidNatives);
      //rmAddObjectDefConstraint(cow5ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow5ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow5ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow5ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow5ID, 0, 0.08, 0.70);   
/*----------------------------------------------------------------------------------------------------------------*/
      //int cow6ID = rmCreateObjectDef("cow 6"+i);
	    int cow6ID = rmCreateObjectDef("cow 6");
	  //rmAddObjectDefItem(cow6ID, "cow", rmRandInt(8,10), 0.0);
	    rmAddObjectDefItem(cow6ID, "cow", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(cow6ID, 0.0);
      //rmSetObjectDefMaxDistance(cow6ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(cow6ID, 0.0);
	  //rmAddObjectDefConstraint(cow6ID, avoidCoinFar);
      //rmAddObjectDefConstraint(cow6ID, avoidAll);
      //rmAddObjectDefConstraint(cow6ID, avoidWater8);
	  //rmAddObjectDefConstraint(cow6ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(cow6ID, avoidNatives);
      //rmAddObjectDefConstraint(cow6ID, avoidNuggetsSmall);
	  //rmAddObjectDefConstraint(cow6ID, Westconstraint);
	  //rmAddObjectDefConstraint(cow6ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(cow6ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(cow6ID, 0, 0.9, 0.29);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE HUNTABLE ANIMALS: ************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      //int elk1ID = rmCreateObjectDef("elk 1"+i);
	    int elk1ID = rmCreateObjectDef("elk 1");
	  rmAddObjectDefItem(elk1ID, "elk", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(elk1ID, 0.0);
      rmSetObjectDefMaxDistance(elk1ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(elk1ID, avoidCoin);
      rmAddObjectDefConstraint(elk1ID, avoidAll);
	  rmAddObjectDefConstraint(elk1ID, avoidSocket);
	  rmAddObjectDefConstraint(elk1ID, avoidElk);
	  rmAddObjectDefConstraint(elk1ID, elkAvoidElk);
	  rmAddObjectDefConstraint(elk1ID, avoidWater8);
	  rmAddObjectDefConstraint(elk1ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(elk1ID, avoidNatives);
      //rmAddObjectDefConstraint(elk1ID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(elk1ID, Eastconstraint);
	  rmAddObjectDefConstraint(elk1ID, elkEdgeConstraint);
	  // rmPlaceObjectDefAtLoc(elk1ID, 0, 0.5, 0.5);
	     rmPlaceObjectDefAtLoc(elk1ID, 0, 1.0, 0.0, cNumberNonGaiaPlayers);
/*----------------------------------------------------------------------------------------------------------------*/
      //int elk2ID = rmCreateObjectDef("elk 2"+i);
	    int elk2ID = rmCreateObjectDef("elk 2");
	  rmAddObjectDefItem(elk2ID, "elk", rmRandInt(8,10), 6.0);
      rmSetObjectDefMinDistance(elk2ID, 0.0);
      rmSetObjectDefMaxDistance(elk2ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(elk2ID, avoidCoin);
      rmAddObjectDefConstraint(elk2ID, avoidAll);
	  rmAddObjectDefConstraint(elk2ID, avoidSocket);
	  rmAddObjectDefConstraint(elk2ID, avoidElk);
	  rmAddObjectDefConstraint(elk2ID, elkAvoidElk);
	  rmAddObjectDefConstraint(elk2ID, avoidWater8);
	  rmAddObjectDefConstraint(elk2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(elk2ID, avoidNatives);
      //rmAddObjectDefConstraint(elk2ID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(elk2ID, Westconstraint);
	  rmAddObjectDefConstraint(elk2ID, elkEdgeConstraint);
	  // rmPlaceObjectDefAtLoc(elk2ID, 0, 0.5, 0.5);
	     rmPlaceObjectDefAtLoc(elk2ID, 0, 0.0, 1.0, cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	// DEFINE AND PLACE THE NUGGET EASY SE:
	int nuggeteasyID= rmCreateObjectDef("nugget easy SE"); 
	rmAddObjectDefItem(nuggeteasyID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(nuggeteasyID, 0.0);
	rmSetObjectDefMaxDistance(nuggeteasyID, rmXFractionToMeters(0.5));
  	rmAddObjectDefConstraint(nuggeteasyID, avoidNuggetFar);
	  //rmAddObjectDefConstraint(nuggeteasyID, avoidNugget);
  	//rmAddObjectDefConstraint(nuggeteasyID, avoidTownCenter);
  	rmAddObjectDefConstraint(nuggeteasyID, avoidTradeRoute);
	rmAddObjectDefConstraint(nuggeteasyID, nuggetEdgeConstraint);
  	rmAddObjectDefConstraint(nuggeteasyID, avoidAll);
	rmAddObjectDefConstraint(nuggeteasyID, avoidSocket);
	rmAddObjectDefConstraint(nuggeteasyID, avoidElk);
  	rmAddObjectDefConstraint(nuggeteasyID, avoidImpassableLand);
	rmAddObjectDefConstraint(nuggeteasyID, Westconstraint);
	//rmPlaceObjectDefAtLoc(nuggeteasyID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
	  rmPlaceObjectDefAtLoc(nuggeteasyID, 0, 0.0, 1.0, cNumberNonGaiaPlayers*1.5);
/*----------------------------------------------------------------------------------------------------------------*/
	// DEFINE AND PLACE THE NUGGET EASY NW:
	int nuggeteasyNWID= rmCreateObjectDef("nugget easy NW"); 
	rmAddObjectDefItem(nuggeteasyNWID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(nuggeteasyNWID, 0.0);
	rmSetObjectDefMaxDistance(nuggeteasyNWID, rmXFractionToMeters(0.5));
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidNuggetFar);
  	//rmAddObjectDefConstraint(nuggeteasyNWID, avoidTownCenter);
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidTradeRoute);
	rmAddObjectDefConstraint(nuggeteasyNWID, nuggetEdgeConstraint);
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidAll);
	rmAddObjectDefConstraint(nuggeteasyNWID, avoidSocket);
	rmAddObjectDefConstraint(nuggeteasyNWID, avoidElk);
  	rmAddObjectDefConstraint(nuggeteasyNWID, avoidImpassableLand);
	rmAddObjectDefConstraint(nuggeteasyNWID, Eastconstraint);
	//rmPlaceObjectDefAtLoc(nuggeteasyNWID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
	  rmPlaceObjectDefAtLoc(nuggeteasyNWID, 0, 1.0, 0.0, cNumberNonGaiaPlayers*1.5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  //int silverRandom5ID = rmCreateObjectDef("silverRandom 5"+i);
	    int silverRandom5ID = rmCreateObjectDef("silverRandom 5"+i);
	  rmAddObjectDefItem(silverRandom5ID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandom5ID, 0.0);
      rmSetObjectDefMaxDistance(silverRandom5ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(silverRandom5ID, avoidCoinFar);
      rmAddObjectDefConstraint(silverRandom5ID, avoidAll);
	  rmAddObjectDefConstraint(silverRandom5ID, avoidSocket);
	  rmAddObjectDefConstraint(silverRandom5ID, avoidElk);
      rmAddObjectDefConstraint(silverRandom5ID, avoidWater8);
	  rmAddObjectDefConstraint(silverRandom5ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(silverRandom5ID, avoidNatives);
      rmAddObjectDefConstraint(silverRandom5ID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(silverRandom5ID, Eastconstraint);
	  rmAddObjectDefConstraint(silverRandom5ID, coinEdgeConstraint);
	 // rmPlaceObjectDefAtLoc(silverRandom5ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(silverRandom5ID, 0, 1.0, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE AND PLACE THE SILVER MINES RANDOM:
	  for(i=0; < cNumberNonGaiaPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
	{
/*----------------------------------------------------------------------------------------------------------------*/	
	  //int silverRandom6ID = rmCreateObjectDef("silverRandom 6"+i);
	    int silverRandom6ID = rmCreateObjectDef("silverRandom 6"+i);
	  rmAddObjectDefItem(silverRandom6ID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverRandom6ID, 0.0);
      rmSetObjectDefMaxDistance(silverRandom6ID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(silverRandom6ID, avoidCoinFar);
      rmAddObjectDefConstraint(silverRandom6ID, avoidAll);
	  rmAddObjectDefConstraint(silverRandom6ID, avoidSocket);
	  rmAddObjectDefConstraint(silverRandom6ID, avoidElk);
      rmAddObjectDefConstraint(silverRandom6ID, avoidWater8);
	  rmAddObjectDefConstraint(silverRandom6ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(silverRandom6ID, avoidNatives);
      rmAddObjectDefConstraint(silverRandom6ID, avoidNuggetsSmall);
	  rmAddObjectDefConstraint(silverRandom6ID, Westconstraint);
	  rmAddObjectDefConstraint(silverRandom6ID, coinEdgeConstraint);
	  //rmPlaceObjectDefAtLoc(silverRandom6ID, 0, 0.5, 0.5);
	    rmPlaceObjectDefAtLoc(silverRandom6ID, 0, 0.0, 1.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.96);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BISONS 1: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        int BisonID=rmCreateObjectDef("bison herd 1");
        rmAddObjectDefItem(BisonID, "bison", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(BisonID, 0.0);
        rmSetObjectDefMaxDistance(BisonID, 0.0);
		rmAddObjectDefConstraint(BisonID, avoidBison);
	    rmAddObjectDefConstraint(BisonID, bisonAvoidBison);
	    //rmAddObjectDefConstraint(BisonID, avoidTradeRoute);
	    //rmAddObjectDefConstraint(BisonID, avoidImportantItem);
	    //rmAddObjectDefConstraint(BisonID, avoidNugget);
  		//rmAddObjectDefConstraint(BisonID, avoidSocket);
		//rmAddObjectDefConstraint(BisonID, avoidTC);
		//rmAddObjectDefConstraint(BisonID, avoidCoin);
		//rmAddObjectDefConstraint(BisonID, avoidNatives);
  		//rmAddObjectDefConstraint(BisonID, avoidAll);
		//rmAddObjectDefConstraint(BisonID, avoidRiver);
		//rmAddObjectDefConstraint(BisonID, playerEdgeConstraint);
		rmSetObjectDefCreateHerd(BisonID, true);  
		rmPlaceObjectDefAtLoc(BisonID, 0, 0.5, 0.35, cNumberNonGaiaPlayers);	
/*----------------------------------------------------------------------------------------------------------------*/		
// ************************************* DEFINE AND PLACE THE BISONS 2: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        int Bison2ID=rmCreateObjectDef("bison herd 2");
        rmAddObjectDefItem(Bison2ID, "bison", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(Bison2ID, 0.0);
        rmSetObjectDefMaxDistance(Bison2ID, 0.0);
		rmAddObjectDefConstraint(Bison2ID, avoidBison);
	    rmAddObjectDefConstraint(Bison2ID, bisonAvoidBison);
	    //rmAddObjectDefConstraint(Bison2ID, avoidTradeRoute);
	    //rmAddObjectDefConstraint(Bison2ID, avoidImportantItem);
	    //rmAddObjectDefConstraint(Bison2ID, avoidNugget);
  		//rmAddObjectDefConstraint(Bison2ID, avoidSocket);
		//rmAddObjectDefConstraint(Bison2ID, avoidTC);
		//rmAddObjectDefConstraint(Bison2ID, avoidCoin);
		//rmAddObjectDefConstraint(Bison2ID, avoidNatives);
  		//rmAddObjectDefConstraint(Bison2ID, avoidAll);
		//rmAddObjectDefConstraint(Bison2ID, avoidRiver);
		//rmAddObjectDefConstraint(Bison2ID, playerEdgeConstraint);
		rmSetObjectDefCreateHerd(Bison2ID, true);  
		rmPlaceObjectDefAtLoc(Bison2ID, 0, 0.5, 0.65, cNumberNonGaiaPlayers);
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE THE BISONS 3: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        int Bison3ID=rmCreateObjectDef("bison herd 3");
        rmAddObjectDefItem(Bison3ID, "bison", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(Bison3ID, 0.0);
        rmSetObjectDefMaxDistance(Bison3ID, 0.0);
		rmAddObjectDefConstraint(Bison3ID, avoidBison);
	    rmAddObjectDefConstraint(Bison3ID, bisonAvoidBison);
	    //rmAddObjectDefConstraint(Bison3ID, avoidTradeRoute);
	    //rmAddObjectDefConstraint(Bison3ID, avoidImportantItem);
	    //rmAddObjectDefConstraint(Bison3ID, avoidNugget);
  		//rmAddObjectDefConstraint(Bison3ID, avoidSocket);
		//rmAddObjectDefConstraint(Bison3ID, avoidTC);
		//rmAddObjectDefConstraint(Bison3ID, avoidCoin);
		//rmAddObjectDefConstraint(Bison3ID, avoidNatives);
  		//rmAddObjectDefConstraint(Bison3ID, avoidAll);
		//rmAddObjectDefConstraint(Bison3ID, avoidRiver);
		//rmAddObjectDefConstraint(Bison3ID, playerEdgeConstraint);
		rmSetObjectDefCreateHerd(Bison3ID, true);  
		rmPlaceObjectDefAtLoc(Bison3ID, 0, 0.93, 0.60, cNumberNonGaiaPlayers);
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE THE BISONS 4: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        int Bison4ID=rmCreateObjectDef("bison herd 4");
        rmAddObjectDefItem(Bison4ID, "bison", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(Bison4ID, 0.0);
        rmSetObjectDefMaxDistance(Bison4ID, 0.0);
		rmAddObjectDefConstraint(Bison4ID, avoidBison);
	    rmAddObjectDefConstraint(Bison4ID, bisonAvoidBison);
	    //rmAddObjectDefConstraint(Bison4ID, avoidTradeRoute);
	    //rmAddObjectDefConstraint(Bison4ID, avoidImportantItem);
	    //rmAddObjectDefConstraint(Bison4ID, avoidNugget);
  		//rmAddObjectDefConstraint(Bison4ID, avoidSocket);
		//rmAddObjectDefConstraint(Bison4ID, avoidTC);
		//rmAddObjectDefConstraint(Bison4ID, avoidCoin);
		//rmAddObjectDefConstraint(Bison4ID, avoidNatives);
  		//rmAddObjectDefConstraint(Bison4ID, avoidAll);
		//rmAddObjectDefConstraint(Bison4ID, avoidRiver);
		//rmAddObjectDefConstraint(Bison4ID, playerEdgeConstraint);
		rmSetObjectDefCreateHerd(Bison4ID, true);  
		rmPlaceObjectDefAtLoc(Bison4ID, 0, 0.06, 0.38, cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.97);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE FORESTS AREAS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
        //int numTries=16*cNumberNonGaiaPlayers;
		  int numTries=16*cNumberNonGaiaPlayers;
      int failCount=0;
   
   
         for (i=0; <numTries)
   
      { 
	  
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         //rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(350));
		   rmSetAreaSize(forest, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
         //rmSetAreaForestType(forest, "saguenay forest");
		   rmSetAreaForestType(forest, "texas forest dirt");
		 // rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 0.9);
         rmSetAreaForestClumpiness(forest, 0.8);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 10.0);
         rmSetAreaMaxBlobDistance(forest, 30.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         
		 //rmAddAreaConstraint(forest, forestConstraint);
		 
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidRiver);
		 rmAddAreaConstraint(forest, avoidTC);
		 //rmAddAreaConstraint(forest, forestAvoidForest); // REMOVED BY ME:
		 rmAddAreaConstraint(forest, avoidNatives);
		 rmAddAreaConstraint(forest, avoidElk);
		 rmAddAreaConstraint(forest, avoidCoin);
		 rmAddAreaConstraint(forest, avoidCoinFar);
		 rmAddAreaConstraint(forest, forestEdgeConstraint);
         // rmAddAreaConstraint(forest, avoidBeach); // REMOVED BY ENSEMBLE:
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidTradeRoute); 
		 rmAddAreaConstraint(forest, avoidSocket); 
		 rmAddAreaConstraint(forest, avoidStartingUnits); 
         
		 if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
			
      } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.98);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE RANDOM TREES: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int TreeID= rmCreateObjectDef("tree"); 
		//rmAddObjectDefItem(TreeID, "TreeSaguenay", 1, 0.0);
		  rmAddObjectDefItem(TreeID, "TreeTexasDirt", 1, 0.0);
		rmSetObjectDefMinDistance(TreeID, 0.0);
        rmSetObjectDefMaxDistance(TreeID, rmXFractionToMeters(0.5));
		//rmAddObjectDefConstraint(TreeID, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(TreeID, avoidNugget);
  		rmAddObjectDefConstraint(TreeID, avoidSocket);
		rmAddObjectDefConstraint(TreeID, avoidTC);
		rmAddObjectDefConstraint(TreeID, avoidCoin);
		rmAddObjectDefConstraint(TreeID, avoidNatives);
  		rmAddObjectDefConstraint(TreeID, avoidAll);
		rmAddObjectDefConstraint(TreeID, avoidRiver);
		rmAddObjectDefConstraint(TreeID, playerEdgeConstraint);
		rmPlaceObjectDefAtLoc(TreeID, 0, 0.5, 0.5, 60*cNumberNonGaiaPlayers);	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ THIS IS THE END OF THE MAP: ********************************************* //
/*----------------------------------------------------------------------------------------------------------------*/				 

